#include <stdio.h>
#include "parti.h"

#define	 SEND_MATR	510000	/* message id for matrix transpose */
#define	 SEND_SCHED	520000	/* message id for gathering schedules */

struct com_pattern *schedule_gather(n,local_list,maxdim)
int *n,**local_list;
int maxdim;
 
{
  int i,j,k,no;
  int *a,*wrk,n_msgs_to_send; /* used in 1st part */
  int *l,msg_size,node,*send_n,**send_list;  /* used in second part */
  struct com_pattern *out_struct;
  int n_msgs_to_recv;
  int size, f_size, s_size;
  int *msgid;
  static int sched_call = 0;

#ifdef DEBUG 
  trace_enter("schedule_gather"); 
#endif 

  /* find how many messages to be sent in exec phase */
  /* i.e. find the transpose of the original distributed matrix */
  send_n = (int *) malloc(sizeof(int)*PARTI_numnodes);
  msgid = wbuffer->msg_id;
  /* receive elements from other processors */
  for (i = 0, no = 0; i < PARTI_numnodes; i++) {
    if (i == PARTI_mynode)
      continue;
    msgid[no++] = PARTI_irecv(SEND_MATR+i, &send_n[i], 
				sizeof(int), i, PARTI_pid);
  }
  /* send the elements to other processors */
  for(i=1;i<PARTI_numnodes;i++){
    k = (PARTI_mynode+i) % PARTI_numnodes;
    PARTI_csend(SEND_MATR+PARTI_mynode, &n[k], sizeof(int), k, PARTI_pid);
  }  
  send_n[PARTI_mynode] = n[PARTI_mynode];
  /* wait until all asynchronous receives are done */
  for (i = 0; i < no; i++) {
    PARTI_msgwait (msgid[i]);
  }

  /* call asynchronous receive functions */
  send_list = (int **) malloc(sizeof(int *)*PARTI_numnodes);
  for(i = 0, no = 0; i < PARTI_numnodes; i++) {
    if (send_n[i] && (i != PARTI_mynode)) {		/* message size > 0 */
      send_list[i] = (int *) malloc(send_n[i]*sizeof(int));
      msgid[no++] = PARTI_irecv(SEND_SCHED+i,send_list[i],
				send_n[i]*sizeof(int),i,PARTI_pid);
    }
  }

  /* send messages to those who must send messages in exec phase */
  for(i=0;i<PARTI_numnodes;i++){
    if((n[i]>0) && (i != PARTI_mynode)){
      PARTI_csend(SEND_SCHED+PARTI_mynode,local_list[i],sizeof(int)*n[i],i,PARTI_pid);
    }
  }

  /* wait until all asynchronous receives are done */
  for (i = 0; i < no; i++) {
    PARTI_msgwait (msgid[i]);
  }

  /* copy the indexes of local array */
  send_list[PARTI_mynode] = (int *) malloc(n[PARTI_mynode]*sizeof(int));
  for (i = 0; i < n[PARTI_mynode]; i++)
    send_list[PARTI_mynode][i] = local_list[PARTI_mynode][i];

  /* put pointers into structre to be passed out */
  out_struct = (struct com_pattern *) malloc(sizeof(struct com_pattern));
  out_struct->buffer_size = 0;
  f_size = s_size =  0;
  for(i=0;i<PARTI_numnodes;i++){
    if(out_struct->buffer_size<send_n[i]){
      out_struct->buffer_size = send_n[i];
    }
    s_size += send_n[i];
    f_size += n[i];
  }
  size = (s_size < f_size)? f_size: s_size; 

  if (wbuffer->max_size < (size*maxdim*sizeof(double))) {
    free(wbuffer->buffer); 
    wbuffer->buffer = (char *)malloc((size*maxdim)*sizeof(double)); 
    if (NULL == wbuffer->buffer)
      fprintf(stderr,"ERROR:not enough memory -parti working buffer\n"),exit(0);
    wbuffer->max_size = size * maxdim * sizeof(double);
  }
  n_msgs_to_recv = 0;
  n_msgs_to_send = 0;
  for (i = 0; i < PARTI_numnodes; i++) {
    if (n[i]) n_msgs_to_recv++;
    if (send_n[i]) n_msgs_to_send++;
  }

  out_struct->n_msgs_to_recv = n_msgs_to_recv;
  out_struct->n_msgs_to_send = n_msgs_to_send;
  out_struct->send_n = send_n;
  out_struct->send_list = send_list;
  out_struct->fetch_n = n;
  out_struct->fetch_list = local_list;
  out_struct->dimen = maxdim;
  out_struct->send_size = NULL;
  out_struct->fetch_size = NULL;
  out_struct->total_send_size = s_size;
  out_struct->total_fetch_size = f_size;

 sched_call++;
#ifdef DEBUG
  trace_exit();
#endif
 
  return(out_struct);
}  
